package adt.sequence;


public class Subsequence<T> implements Sequence<T>
{
	private Sequence<T> original;
	private int         start;
	private int         end;


	public Subsequence (Sequence<T> original, int start, int end)
	{
		this.original = original;
		this.start = start;
		this.end = end;
	}


	public int size()
	{
		return end-start+1;
	}

	public T get (int index)
	{
		if ((index>=0) && (index<size()) )
			return original.get(start+index);
		else
			return null;
	}

}
